﻿/* Letzte Änderung: 2020-06-24 /hb
**********************************/

(function ($) {

    const duration = 600;
    const durationNotrans1 = 200;
    const durationNotrans2 = 260;

    $.fn.sliderTouch = function (params) {
        
        params = $.extend({ nav: true }, params);

        var $this = $(this);

        $this.wrap = $(".slider-wrap");
        var len = $this.wrap.children().length;

        var navigation = new Navigation($this, len);
        var totalwidth = 0;

        if (params.nav == true) {
            navigation.show();
        }

        fixSlidersIn($this.wrap, $this.width());

        $this.wrap.children().each(function () {
            totalwidth += parseFloat($(this).width());
            $(this).css("float", "left");
        });
        $this.wrap.width(totalwidth);


        function NoTransitionNext(elem) {
            var elemOffset = elem.offset().left - elem.parent().offset().left;
            var rash = Math.floor($(this).width() / 8);
            var elemOffsetWithRash = elemOffset + rash;
            $this.wrap.width(totalwidth + rash);
            elem.parent().parent().animate({ scrollLeft: elemOffsetWithRash }, durationNotrans1, "easeOutQuart");
            elem.parent().parent().animate({ scrollLeft: elemOffset }, durationNotrans2, "swing", function() {$this.wrap.width(totalwidth);});
        }

        function NoTransitionPrev(elem) {
            var rash = Math.floor($(this).width() / 8);
            elem.parent().parent().animate({ 'margin-left' : rash }, durationNotrans1, "easeOutQuart");
            elem.parent().parent().animate({ 'margin-left' : 0 }, durationNotrans2, "swing");
        }

        $(this).on("swipeleft", function () {
            if (navigation.index < len - 1) {
                navigation.index++;
                aktIndex = navigation.index;
                navigation.changeNavPos();
                var elem = $this.wrap.children("div:eq(" + navigation.index + ")");
                Transition(elem, duration);
            } else {
                if (nextClick == 0) {
                    var elem = $this.wrap.children("div:eq(" + navigation.index + ")");
                    NoTransitionNext(elem);
                }
            }
        });

        $(this).on("swiperight", function () {
            if (navigation.index > 0) {
                navigation.index--;
                aktIndex = navigation.index;
                navigation.changeNavPos();
                var elem = $this.wrap.children("div:eq(" + navigation.index + ")");
                Transition(elem, duration);
            } else {
                var elem = $this.wrap.children("div:eq(" + navigation.index + ")");
                NoTransitionPrev(elem);
            }
        });

        refresh = function() {
            fixSlidersIn($this.wrap, $this.width());
            totalwidth = 0;
            $this.wrap.children().each(function () {
                totalwidth += parseFloat($(this).width());
                $(this).css("float", "left");
            });
            $this.wrap.width(totalwidth);
            var elem = $this.wrap.children("div:eq(" + navigation.index + ")");
            Transition(elem, 0);
        };

        $(window).resize(function () {
            refresh();
        });

        $( window ).on( "orientationchange", function( event ) {
            refresh();
        });

        return this;
    };

    
    function fixSlidersIn(objWrap,withWidth) {
        objWrap.children().each(function () {
            $(this).width(withWidth);
        });
    }

    function Navigation(slider, len) {
        
        this.index = 0;
        var nav = $('<nav></nav>');
        var ul = $('<ul></ul>');


        function addNav() {
            slider.append(nav.append(ul));

            for (var i = 0; i < len; i++) {
                var li = $('<li></li>');
                ul.append(li);
            }
            nav.hide();
        }
        addNav();

        this.changeNavPos = function () {
            ul.children("li").removeClass("on");
            ul.children("li:eq(" + this.index + ")").addClass("on");

            if (this.index == 0) {
                $('#prev').addClass("disabled");
            } else {
                $('#prev').removeClass("disabled");
            }
            if (this.index == len - 1) {
                $('#next').addClass("disabled");
            } else {
                $('#next').removeClass("disabled");
            }
        }
        this.changeNavPos();

        var $this = this;

        ul.children("li").bind('click', function () {
            $this.index = $(this).index();
            aktIndex = $this.index;
            $this.changeNavPos($this.index);
            var elem = slider.wrap.children("div:eq(" + $this.index + ")");
            Transition(elem, duration);
        });

        this.show = function () {
            nav.show();
        }
    }

    function Transition(elem, duration) {
        var elemOffset = elem.offset().left - elem.parent().offset().left;
        elem.parent().parent().animate({ scrollLeft: elemOffset }, duration, "easeOutQuart");
    }

})(jQuery);